; **********************************************************************************************************
;
;                                              MConv V1.6
;                               (http://plus4.emucamp.com/sd.php?pid=15096)
;
;                                                  By
;
;                                       Hrsfalvi, Levente (TLC)
;                               (http://plus4.emucamp.com/md.php?mid=1039)
;
;
; **********************************************************************************************************
		org 	$4000-2             ; -2 since we have to include a LOAD address
		db		$00,$40           	; LOAD address (for .PRG file)


MultiPlexPeriod	equ	$03
SIDREG			equ	$d400			; $fd40 DOES NOT WORK!! This is due to there being no RAM under the IO area
ZeroPageSpace	equ	$40


L0200	equ	$0200
L0201	equ	$0201
L0202	equ	$0202
L0203	equ	$0203
L0204	equ	$0204
L020a	equ	$020a
L0211	equ	$0211

L40		equ	ZeroPageSpace
L41		equ	ZeroPageSpace+1
L48		equ	ZeroPageSpace+2

Ld400	equ	SIDREG
Ld401	equ	SIDREG+1
Ld404	equ	SIDREG+4
Ld405	equ	SIDREG+5
Ld406	equ	SIDREG+6


TedFreqConvert:
		jsr	$1003					; Normal Music player
		ldx	#$0e
L4005:
		jsr	L40a5
		jsr	L40b2
		jsr	L4139
		jsr	L4187
		jsr	L4194
		txa
		sec
		sbc	#$07
		tax
		bpl L4005

		jsr	L41a1
		jsr	L41cf
		ldx	L0200
		lda	Ld404,x
		beq	L402d
		and	#$80
		beq	L4034

L402d:	ldx	#$fe
		ldy	#$03
		bne	L403e			

L4034:	lda	Ld400,x
		ldy	Ld401,x
		tax
		jsr	L4200

L403e:	stx	$ff0e
		tya
		and	#$03
		sta	L404c+1
		
		lda	$ff12
		and	#$fc									   
L404c:	ora	#$01
		sta	$ff12

		ldx	L0201
		lda	Ld404,x
		bne	L4060
		ldx	#$fe
		ldy	#$03
		bne	L406a		

L4060:	lda	Ld400,x
		ldy	Ld401,x
		tax
		jsr	L4200
L406a:	stx	$ff0f
		sty	$ff10

		ldx	L0201
		lda	Ld404,x
		and	#$80
		bne	L4085
		lda	L0202
		ora	#$30
		sta	$ff11
		bne	L408d			

L4085:	lda	L0202
		ora	#$50
		sta	$ff11

L408d:	ldx	#$01
		lda	L4350,x
		sta	L0200
		lda	L4354,x
		sta	L0201
		dex
		bpl	L40a1
		ldx	#MultiPlexPeriod	; -- Period of multiplexing ($409f; the value here is effectively P-1 )
L40a1:	stx	L408d+1
		rts


L40a5:	lda	L0203,x
		cmp	#$ff
		bne	L40b1
		lda	#$01
		sta	L0204,x
L40b1:	rts


L40b2:	lda	Ld404,x
		and	#$01
		bne	L40ba
		rts


L40ba:	lda	L0204,x
		bne	L40e7
		lda	Ld405,x
		lsr		
		lsr		
		lsr		
		lsr
		tay
		lda	L0202,x
		clc
		adc	L4260,y
		sta	L0202,x
		lda	L0203,x
		adc	L4270,y
		sta	L0203,x
		bcc	L40e6
		lda	#$ff
		sta	L0202,x
		sta	L0203,x
L40e6:	rts



L40e7:	jsr	L40f8
		lda	Ld406,x
		and	#$f0
		cmp	L0203,x
		bcc	L40f7
		sta	L0203,x
L40f7	rts


L40f8:	ldy	#$05
		lda	L0203,x
L40fd:	cmp	L4280,y
		bcc	L4107
		dey
		bne	L40fd

L4107:	lda	L4288,y
		pha
		lda	Ld405,x
		and	#$0f
		sta	L4118+1
		pla
		clc
L4118:	adc	#$00			

AdderCode:					; This is the same as the code below... so it now jumps here....
		tay
		lda	L0202,x
		sec
		sbc	L4290,y
		sta	L0202,x
		lda	L0203,x			
		sbc	L42a0,y
		sta	L0203,x
		bcs	L4138
		lda	#$00			
		sta	L0202,x
		sta	L0203,x
L4138:	rts


L4139:	lda	Ld404,x
		and	#$01
		beq	L4141
		rts
L4141:	lda	#$00
		sta	L0204,x
		ldy	#$05
		lda	L0203,x
L414b:	cmp	L4280,y
		bcc	L4155
		dey
		bne	L414b

L4155:	lda	L4288,y
		pha
		lda	Ld406,x
		and	#$0f
		sta	L4166+1
		pla
		clc
L4166:	adc	#$06
		jmp	AdderCode		; Duplicate code removed


L4187:	lda	L0203,x
		cmp	#$04
		bcs	L4193
ClearReg:
		lda	#$00
		sta	Ld404,x
L4193:	rts



L4194:	lda	Ld404,x
		and	#$06
		bne	ClearReg
L41a0:	rts


L41a1:	lda	#$00
		sta	L48
		lda	L0203
		clc
		adc	L020a
		bcc	L41b0
		inc	L48
		clc
L41b0:	
		adc	L0211
		bcc	L41b8
		inc	L48

L41b8:	lsr	L48
		ror
		lsr	L48
		ror
		lsr	L48
		ror
		lsr	L48
		ror
		lsr	L48
		ror
		tax
		lda	L4358,x
		sta	L0202
		rts


L41cf:	ldx	L0200
		lda	Ld404,x
		beq	L41df
		ldx	L0201
		lda	Ld404,x
		bne	L41eb
L41df:	lda	L4370,x
		sta	L0200
		lda	L4371,x
		sta	L0201
L41eb:	ldx	L0200
		lda	Ld404,x
		and	#$80
		bne	L41f6
L41f5:	rts

L41f6:	ldy	L0201
		stx	L0201
		sty	L0200
		rts


L4200:	cpy	#$00
		beq	L424e
		stx	L40
		sty	L41
		tya
		cmp	#$10
		bcc	L421b
		ldx	#$fe
		tya
		bmi	L4226
L4212:	inx
		asl	L40
		rol
		bpl	L4212
		tay
		bmi	L4226
L421b:	ldx	#$06
L421d	lsr
		ror	L40
		dex
		tay
		bne	L421d
		ldy	L40
L4226:	lda	L4300,y
		cpx	#$00
		beq	L4233
		bpl	L4237
L422f:	lsr
		inx
		bmi	L422f
L4233:	ldy	#$03
		bne	L424a
L4237	sta	L40
		lda	#$00
L423b:	asl	L40
		rol
		cmp	#$02
		bcs	L4245
		dex
		bne	L423b
L4245:	eor	#$ff
		tay
		lda	L40
L424a:	eor	#$ff
		tax
		rts
L424e:	ldx	#$fd
L4250:	ldy	#$03
		rts

L4253:	db		$00,$54,$4C,$43,$20,$31,$2E,$36,$20,$32,$30
		db		$30,$35
L4260:	db		$FF,$FF,$FF,$FF,$FF,$55,$FF,$33,$AA,$B1,$D8,$3E,$05,$AC,$03,$A1
L4270:	db		$FF,$FF,$FF,$7F,$7F,$55,$3F,$33,$2A,$13,$09,$06,$05,$01,$01,$00

L4280:	db		$5D,$36,$1A,$0E,$06,$00,$00,$00
L4288:	db		$00,$20,$40,$60,$80,$A0,$00,$00
L4290:	db		$80,$80,$80,$80,$80,$66,$66,$00,$24,$BA,$86,$96,$80,$9E,$FC,$9E
L42a0:	db		$28,$28,$28,$28,$28,$20,$20,$1B,$17,$0E,$08,$05,$04,$01,$00,$00
		db		$00,$00,$00,$00,$80,$80,$00,$80,$80,$CC,$55,$C9,$70,$D0
		db		$7E,$4F,$27,$27,$27,$27,$13,$13,$0D,$13,$13,$07,$04,$02,$02,$00
		db		$00,$00,$00,$00,$00,$00,$00,$00,$00,$55,$55,$00,$55,$8E,$37,$48
		db		$40,$28,$1C,$1C,$1C,$0E,$0E,$0E,$0E,$09,$09,$04,$02,$01,$01,$00
		db		$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$17,$B4,$92,$71
		db		$1F,$13
		
L4300:	db		$0C,$0C,$06,$06,$04,$03,$03,$04,$04,$02,$01,$00,$00,$00
		db		$00,$00,$00,$00,$00,$00,$00,$AA,$AA,$AA,$00,$24,$92,$61,$4E,$1A
		db		$10,$0A,$08,$04,$04,$04,$04,$02,$02,$02,$02,$01,$00,$00,$00,$00
		db		$00,$00,$00,$00,$00,$00,$00,$00,$00,$80,$33,$99,$50,$33,$29,$0E
		db		$08,$05,$06,$06,$03,$02,$03,$03,$02,$01,$01,$00,$00,$00,$00,$00
		db		$00,$00

; Multiplex line for first TED channel
L4350:	db		$00,$00,$00,$00

; Multiplex line for Second TED channel
L4354	db		$0e,$0e,$07,$07


L4358	db		$00,$00,$01,$01
		db		$02,$02,$02,$03,$03,$04,$04,$04,$05,$05,$05,$06,$06,$06,$07,$07
		db		$07,$08,$08,$08
L4370:	db		$07
L4371:	db		$0E,$00,$00,$00,$00,$00,$00,$0E,$00,$00,$00,$00,$00
		db		$00,$07,$E6,$E5,$E3,$E1,$DF,$DE,$DC,$DA,$D9,$D7,$D6,$D4,$D3,$D1
		db		$D0,$CE,$CD,$CB,$CA,$C9,$C7,$C6,$C5,$C3,$C2,$C1,$C0,$BE,$BD,$BC
		db		$BB,$B9,$B8,$B7,$B6,$B5,$B4,$B3,$B2,$B1,$B0,$AF,$AD,$AC,$AB,$AA
		db		$A9,$A9,$A8,$A7,$A6,$A5,$A4,$A3,$A2,$A1,$A0,$9F,$9F,$9E,$9D,$9C
		db		$9B,$9A,$9A,$99,$98,$97,$96,$96,$95,$94,$93,$93,$92,$91,$91,$90
		db		$8F,$8E,$8E,$8D,$8C,$8C,$8B,$8A,$8A,$89,$89,$88,$87,$87,$86,$85
		db		$85,$84,$84,$83,$82,$82,$81,$81,$80,$80,$7F,$7F,$7E,$7D,$7D,$7C
		db		$7C,$7B,$7B,$7A,$7A,$79,$79,$78,$78,$77,$77,$76,$76,$75,$75,$75
		db		$74,$74






		








